
% run this script, clustering performance on the five demo data sets will
% be automatically displayed

clear;
clc;

rep_time = 50; % repeat experiment 50 times to obtain average performance
seed_fixed_at = 999; % fix seed point at 999 to ensure reproducibility

%% BC
load BC
x=BC;
pm.no_nom_att = 5;
pm.no_ord_att = 4;
pm.no_num_att = 0;
[ pm.n , pm.d ] = size( x );
label = x( : , pm.d );
pm.d = pm.d - 1;
x = x( : , 1 : pm.d );
pm.k = length( unique( label ) );
pm.no_values=[];
for t = 1 : pm.d
    pm.no_values( t ) = length( unique( x( : , t ) ) );
end
rand( 'seed' , seed_fixed_at );
[ dis_matrix , x_coded , pm ] = prjct_rprst( x , pm );
[ acc_mean , ari_mean] = h2h_ex( x_coded , label , pm , rep_time , dis_matrix );
disp(' ');
disp('clustering peformance on BC data set');
acc_mean
ari_mean

%% HR
load HR
x=HR;
pm.no_nom_att = 2;
pm.no_ord_att = 2;
pm.no_num_att = 0;
[ pm.n , pm.d ] = size( x );
label = x( : , pm.d );
pm.d = pm.d - 1;
x = x( : , 1 : pm.d );
pm.k = length( unique( label ) );
pm.no_values=[];
for t = 1 : pm.d
    pm.no_values( t ) = length( unique( x( : , t ) ) );
end
rand( 'seed' , seed_fixed_at );
[ dis_matrix , x_coded , pm ] = prjct_rprst( x , pm );
[ acc_mean , ari_mean] = h2h_ex( x_coded , label , pm , rep_time , dis_matrix );
disp(' ');
disp('clustering peformance on HR data set');
acc_mean
ari_mean

%% HF
load HF
pm.no_nom_att = 5;
pm.no_ord_att = 0;
pm.no_num_att = 7;
[ pm.n , pm.d ] = size( x );
label = x( : , pm.d );
pm.d = pm.d - 1;
x = x( : , 1 : pm.d );
pm.k = length( unique( label ) );
pm.no_values=[];
for t = 1 : pm.d
    pm.no_values( t ) = length( unique( x( : , t ) ) );
end
rand( 'seed' , seed_fixed_at );
[ dis_matrix , x_coded , pm ] = prjct_rprst( x , pm );
[ acc_mean , ari_mean] = h2h_ex( x_coded , label , pm , rep_time , dis_matrix );
disp(' ');
disp('clustering peformance on HF data set');
acc_mean
ari_mean

%% AA
load AA
pm.no_nom_att = 7;
pm.no_ord_att = 0;
pm.no_num_att = 2;
[ pm.n , pm.d ] = size( x );
label = x( : , pm.d );
pm.d = pm.d - 1;
x = x( : , 1 : pm.d );
pm.k = length( unique( label ) );
pm.no_values=[];
for t = 1 : pm.d
    pm.no_values( t ) = length( unique( x( : , t ) ) );
end
rand( 'seed' , seed_fixed_at );
[ dis_matrix , x_coded , pm ] = prjct_rprst( x , pm );
[ acc_mean , ari_mean] = h2h_ex( x_coded , label , pm , rep_time , dis_matrix );
disp(' ');
disp('clustering peformance on AA data set');
acc_mean
ari_mean

%% MM
load MM
pm.no_nom_att = 4;
pm.no_ord_att = 0;
pm.no_num_att = 1;
[ pm.n , pm.d ] = size( x );
label = x( : , pm.d );
pm.d = pm.d - 1;
x = x( : , 1 : pm.d );
pm.k = length( unique( label ) );
pm.no_values=[];
for t = 1 : pm.d
    pm.no_values( t ) = length( unique( x( : , t ) ) );
end
rand( 'seed' , seed_fixed_at );
[ dis_matrix , x_coded , pm ] = prjct_rprst( x , pm );
[ acc_mean , ari_mean] = h2h_ex( x_coded , label , pm , rep_time , dis_matrix );

disp(' ');
disp('clustering peformance on MM data set');
acc_mean
ari_mean



